diff -urN src.orig/malware.c src/malware.c
--- src.orig/malware.c	Thu Feb 17 16:49:11 2005
+++ src/malware.c	Fri Mar  4 12:07:20 2005
@@ -409,6 +409,7 @@
       uschar buf[32768];
       struct sockaddr_un server;
       int sock;
+      int result;
 
       if ((kav_options = string_nextinlist(&av_scanner_work, &sep,
                                            kav_options_buffer,
@@ -456,19 +457,52 @@
       }
 
       malware_name = NULL;
+      result = 0;
       /* read response lines, find malware name and final response */
       while (recv_line(sock, buf, 32768) > 0) {
         debug_printf("aveserver: %s\n", buf);
-        if (buf[0] == '2') break;
-        if (Ustrncmp(buf,"322",3) == 0) {
+        if (buf[0] == '2') {
+	  break;
+	} else if (buf[0] == '5') {
+          /* aveserver is having problems */
+          log_write(0, LOG_MAIN|LOG_PANIC,
+             "malware acl condition: unable to scan file %s/scan/%s/%s.eml (Responded: %s).",
+	     spool_directory, message_id, message_id, buf);
+          result = DEFER;
+	  break;
+	} else if (Ustrncmp(buf,"322",3) == 0) {
           uschar *p = Ustrchr(&buf[4],' ');
           *p = '\0';
           Ustrcpy(malware_name_buffer,&buf[4]);
           malware_name = malware_name_buffer;
-        };
+	};
       }
 
+      /* prepare our command */
+      snprintf(CS buf, 32768, "quit\r\n");
+      
+      /* and send it */
+      if (send(sock, buf, Ustrlen(buf), 0) < 0) {
+        close(sock);
+        log_write(0, LOG_MAIN|LOG_PANIC,
+             "malware acl condition: unable to write to aveserver UNIX socket (%s)", kav_options);
+        return DEFER;
+      }
+
+      /* read aveserver's greeting and see if it is ready (2xx greeting) */
+      recv_line(sock, buf, 32768);
+
+      if (buf[0] != '2') {
+        /* aveserver is having problems */
+        close(sock);
+        log_write(0, LOG_MAIN|LOG_PANIC,
+             "malware acl condition: unable to quit aveserver dialogue (Responded: %s).", ((buf[0] != 0) ? buf : (uschar *)"nothing") );
+        return DEFER;
+      };
+
       close(sock);
+
+      if (result == DEFER) return DEFER;
     }
     /* "fsecure" scanner type ------------------------------------------------- */
     else if (strcmpic(scanner_name,US"fsecure") == 0) {
